function fillArtists(letter) {
	var httpRequest = createXMLHttpRequest();
	var url = 'ControllerServlet?action=BrowseMusic&startingLetter=' + letter;
	httpRequest.open('GET', url, true);
	httpRequest.onreadystatechange = function() {
		if (this.readyState == 4 && this.status == 200) {
			cleanList("artist");
			cleanList("album");
			cleanList("track");
			modifyList(this, "artist");
		}
	};
	httpRequest.send(null);
}

function fillAlbums() {
	var artistName = getChosenName("artist");
	var httpRequest = createXMLHttpRequest();
	var url = 'ControllerServlet?action=BrowseMusic&artist=' + artistName;
	httpRequest.open('GET', url, true);
	httpRequest.onreadystatechange = function() {
		if (this.readyState == 4 && this.status == 200) {
			cleanList("album");
			cleanList("track");
			modifyList(this, "album");
		}
	};
	httpRequest.send(null);
}

function fillTracks() {
	var artistName = getChosenName("artist");
	var albumName = getChosenName("album");
	var httpRequest = createXMLHttpRequest();
	var url = 'ControllerServlet?action=BrowseMusic&artist=' + artistName
			+ '&album=' + albumName;
	httpRequest.open('GET', url, true);
	httpRequest.onreadystatechange = function() {
		if (this.readyState == 4 && this.status == 200) {
			cleanList("track");
			modifyList(this, "track");
		}
	};
	httpRequest.send(null);
}

function modifyList(httpRequest, tagName) {
	var xmlDocument = httpRequest.responseXML;
	var nodeList = xmlDocument.getElementsByTagName(tagName);
	if (tagName == "artist") {
		if (nodeList.length == 0) {
			$('#noArtist').text('No artists with this letter');
		} else {
			$('#noArtist').text('');
		}
	}
	for ( var i = 0; i < nodeList.length; i++) {
		if (nodeList.item(i).childNodes.length > 1) {
			var id = nodeList.item(i).firstChild.firstChild.data;
			var name = nodeList.item(i).lastChild.firstChild.data;
			addId(id, name, tagName);
		} else {
			var name = nodeList.item(i).firstChild.data;
			add(name, tagName);
		}
	}
}

function add(name, tagName) {
	var select = document.getElementById(tagName);
	var y = document.createElement('option');
	y.text = name;
	select.add(y, null);
}

function addId(id, name, tagName) {
	var select = document.getElementById(tagName);
	var y = document.createElement('option');
	y.setAttribute("id", id);
	y.text = name;
	select.add(y, null);
}

function cleanList(tagName) {
	var select = document.getElementById(tagName);
	for ( var i = select.options.length - 1; i >= 0; i--) {
		select.remove(i);
	}
	var y = document.createElement('option');
	y.text = "- - -";
	select.add(y, null);
}

function getChosenName(selectId) {
	var select = document.getElementById(selectId);
	var selectedOption = select.options[select.selectedIndex];
	return selectedOption.value;
}

function playMusic() {
	var select = document.getElementById("track");
	var musicId = select.options[select.selectedIndex].id;
	window.location = "ControllerServlet?action=PlayMusic&id=" + musicId;
}

function createXMLHttpRequest() {
	try {
		return new ActiveXObject("Msxml2.XMLHTTP");
	} catch (e) {
	}
	try {
		return new ActiveXObject("Microsoft.XMLHTTP");
	} catch (e) {
	}
	try {
		return new XMLHttpRequest();
	} catch (e) {
	}
	alert("XMLHttpRequest not supported");
	return null;
}